Summary: A transparent layer library that catches stack and buffer overflows.
Name: libsafe
Version: 0.1.3
Release: olc
Exclusivearch: i386
Exclusiveos: Linux
Copyright: GNU LGPL
Group: System Environment/Libraries
URL: http://www.bell-labs.com/org/11356/libsafe.html
Source: http://www.bell-labs.com/org/11356/src/libsafe-1.3.tgz
Packager: Ole Craig <www.cs.umass.edu/~olc>
Patch0: libsafe-rpmbuild.patch
Patch1: libsafe-email.patch
Buildroot: /var/tmp/rpmbuildroot/libsafe

%description 
	The libsafe package provides libsafe, a low-level library that
	catches stack/buffer overflow attempts common in remote
	cracking exploits.

	You'll probably want to give libsafe a try if you're concerned
	about remote-root cracking attempts.

%prep
%setup -n libsafe
%patch0 -p1
%patch1 -p0

%build
make 

%install
export PATH=/sbin:$PATH
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/{lib,etc}
mkdir -p $RPM_BUILD_ROOT/usr/{lib,man/man8}
make install TOPDIR=$RPM_BUILD_ROOT
cd $RPM_BUILD_ROOT/lib && ln -s libsafe.so.1.3 libsafe.so.1
touch $RPM_BUILD_ROOT/etc/libsafe.notify
%clean
rm -fr $RPM_BUILD_ROOT


%changelog
* Tue Apr 25 2000 Ole Craig <olc@cs.umass.edu>
- build for linux (RH 6.2)
- patch src/Makefile for RPM relocation during build
- check for libsafe in /etc/ld.so.preload before removing


%post
/sbin/ldconfig
cat <<EOF 

libsafe has been installed. You must add it to your LD_PRELOAD
environment variable in order to avail yourself of the protection it
affords.

To use libsafe for system functions (including setuid executables) you must
add the following line to /etc/ld.so.preload:

    libsafe.so.1

If you wish to have email notification of violations caught by
libsafe, add the appropriate email address to /etc/libsafe.notify.

EOF

%preun
if [ -r /etc/ld.so.preload ]; then
    TMPFILE=/tmp/.rpm.libsafe-cleanup
    grep -v libsafe /etc/ld.so.preload > $TMPFILE
    cp -f $TMPFILE /etc/ld.so.preload && rm -f $TMPFILE
fi
if [ -e /etc/ld.so.preload ]; then
    fgrep libsafe /etc/ld.so.preload && (echo "Yikes! Failed automatic removal of libsafe from /etc/ld.so.preload! "; echo "Remove by hand before running 'rpm -e'. Exiting..."; exit 1)
fi

%postun
/sbin/ldconfig

%files
%defattr(-,root,root)
%config /etc/libsafe.notify
/usr/man/man8/*
/lib/libsafe.so.1
/lib/libsafe.so.1.3


